Signed-off-by: Mark Salyzyn <msalyzyn@us.xyratex.com>

 drivers/scsi/libsas/sas_expander.c |    6 +++++-
 include/scsi/libsas.h              |    1 +
 include/scsi/sas.h                 |    6 ++++--
 3 files changed, 10 insertions(+), 3 deletions(-)

diff -ru scsi-misc-2.6/drivers/scsi/libsas/sas_expander.c scsi-misc-2.6.new/drivers/scsi/libsas/sas_expander.c
--- scsi-misc-2.6/drivers/scsi/libsas/sas_expander.c	2011-08-31 08:32:21.000000000 -0400
+++ scsi-misc-2.6.new/drivers/scsi/libsas/sas_expander.c	2011-08-31 09:07:31.000000000 -0400
@@ -331,6 +331,7 @@
 	dev->ex_dev.num_phys = min(rg->num_phys, (u8)MAX_EXPANDER_PHYS);
 	dev->ex_dev.conf_route_table = rg->conf_route_table;
 	dev->ex_dev.configuring = rg->configuring;
+	dev->ex_dev.table_to_table = rg->table_to_table;
 	memcpy(dev->ex_dev.enclosure_logical_id, rg->enclosure_logical_id, 8);
 }
 
@@ -1239,7 +1240,10 @@
 					res = -ENODEV;
 				}
 			} else if (parent_phy->routing_attr == TABLE_ROUTING &&
-				   child_phy->routing_attr != SUBTRACTIVE_ROUTING) {
+				   child_phy->routing_attr !=
+					SUBTRACTIVE_ROUTING &&
+				   (child_ex->table_to_table == 0 ||
+				    child_phy->routing_attr != TABLE_ROUTING)) {
 				sas_print_parent_topology_bug(child, parent_phy, child_phy);
 				res = -ENODEV;
 			}
diff -ru scsi-misc-2.6/include/scsi/libsas.h scsi-misc-2.6.new/include/scsi/libsas.h
--- scsi-misc-2.6/include/scsi/libsas.h	2011-08-31 08:32:22.000000000 -0400
+++ scsi-misc-2.6.new/include/scsi/libsas.h	2011-08-31 09:07:31.000000000 -0400
@@ -144,6 +144,7 @@
 	u8     num_phys;
 	u8     configuring:1;
 	u8     conf_route_table:1;
+	u8     table_to_table:1;
 	u8     enclosure_logical_id[8];
 
 	struct ex_phy *ex_phy;
diff -ru scsi-misc-2.6/include/scsi/sas.h scsi-misc-2.6.new/include/scsi/sas.h
--- scsi-misc-2.6/include/scsi/sas.h	2011-08-31 08:32:22.000000000 -0400
+++ scsi-misc-2.6.new/include/scsi/sas.h	2011-08-31 09:07:31.000000000 -0400
@@ -341,7 +341,8 @@
 
 	u8      conf_route_table:1;
 	u8      configuring:1;
-	u8      _r_b:6;
+	u8      _r_b:5;
+	u8      table_to_table:1;
 
 	u8      _r_c;
 
@@ -528,7 +529,8 @@
 	u8      _r_a;
 	u8      num_phys;
 
-	u8      _r_b:6;
+	u8      table_to_table:1;
+	u8      _r_b:5;
 	u8      configuring:1;
 	u8      conf_route_table:1;
 
